package com.org.hktshop.Interface.product;

import com.org.hktshop.entity.Page;
import com.org.hktshop.entity.product.HktGoodItem;
import com.org.hktshop.entity.product.HktGoods;
import com.org.hktshop.entity.product.HktPriceRegulation;

import java.math.BigDecimal;
import java.rmi.MarshalException;
import java.util.List;
import java.util.Map;

/**
 * @author owen
 */
public interface IHktPriceRegulationService {

    /**
     * 新增/修改价格规则
     * @param priceRegulation
     * @throws Exception
     */
    void updatePriceTemplate(HktPriceRegulation priceRegulation) throws Exception;

    /**
     * 删除价格规则
     * @param priceRegulation
     */
    void delPriceTemplate(HktPriceRegulation priceRegulation);

    /**
     * 分页查询价格规则
     * @param priceRegulation
     * @return
     */
    Object queryPriceRegulationByPage(HktPriceRegulation priceRegulation);

    /**
     * 查找价格规则
     * @param priceRegulation
     * @return
     */
    HktPriceRegulation findPriceRegulation(HktPriceRegulation priceRegulation);


    /**
     * 封装商品数据
     * @param list
     * @return
     */
    void callPriceRegulation(List<HktGoodItem> list);
    void callPriceRegulation(HktGoods item);

    /**
     * 获取价格规则
     * param id,language,num
     * return price 商品价格  realPrice 成交价格
     * return totalMoney  总价  discount 优惠价格
     */
    Map<String,Object> getPriceRegulationInfo(HktGoodItem hktGoodItem);

    Map<String,Object> xcxgetPriceRegulationInfo(HktGoodItem hktGoodItem);

    /**
     * 初始化数据
     */
    void initData();
}
